#!/usr/bin/env python3
import os
import pickle

import scipy

with open('knn.pkl', 'rb') as f:
    clf, inv_I = pickle.load(f)

chars = [None] * 32
for filename in os.listdir('chars'):
    if filename.endswith('.png'):
        im = scipy.misc.imread(os.path.join('chars', filename), mode='L')
        im = im.flatten().reshape(1, -1)
        i = clf.predict(im)[0]
        n = int(os.path.splitext(os.path.basename(filename))[0])
        chars[n] = inv_I[i]
flag = ''.join(chars).replace('-', '/')
print('The flag is:', flag)
