#!/usr/bin/env python3
import os
import pickle

import numpy as np
import scipy.misc
import sklearn.neighbors


def load_training_set():
    X, Y = [], []
    for filename in os.listdir('training-chars'):
        if filename.endswith('.png'):
            im = scipy.misc.imread(os.path.join('training-chars', filename), mode='L')
            im = im.flatten()
            X.append(im)
            Y.append(filename[0])  # first character of the filename is the label
    return np.asarray(X), np.asarray(Y)


X, Y = load_training_set()
inv_I, I = np.unique(Y, return_inverse=True)

clf = sklearn.neighbors.KNeighborsClassifier(1)
clf.fit(X, I)
with open('knn.pkl', 'wb') as f:
    pickle.dump([clf, inv_I], f)
